! C. Dumas Nov 2008
! attention le calcul de MK (ligne d'echouage de GMT) est fait dans masque.F
! avec des geoplace !!!
! nouveau calcul des volumes 

module  output_snowball_mod

       USE module3D_phy

implicit none

!real ::  vol ; !integer :: np  ! declares dans 3D-physique-gen_mod.f90
integer :: npflot                     ! nbr points flottants
real ::  bmean                        ! BM moyen
real ::  accmean                      ! accumulation moyenne
real ::  ablmean                      ! ablation moyenne
real ::  calvmean                     ! moyenne calving
real ::  ablbordmean                  ! ?
real ::  bmeltmean                    ! moyenne fusion basale
real ::  tbmean                       ! temperature basale moyenne
real ::  tbdotmean                    ! moyenne variation / temps temperature basale
real ::  vsmean                       ! vitesse de surface moyenne
real ::  uzsdotmean                   ! moyenne variation / temps vitesse verticale de surface
real ::  uzkmean                      ! moyenne vitesse verticale de surface
real ::  hdotmean                     ! moyenne derivee / temps de h
real ::  volf                         ! volume au dessus de la flottaison
real ::  volflot                      ! volume ice-shelves
real ::  Smax                         ! Altitude max de la surface

real ::  Hmin=5.                      ! epaisseur mini de glace pour calcul sur calotte

CONTAINS

subroutine init_outshort

!ndisp sorite courte tous les ndisp
NDISP=100
end subroutine init_outshort


subroutine shortoutput

! 1_initialization
!------------------
      vol=0. 
      np=0
      npflot=0
      hmax=0. 
      smax=0.
      bmean=0. 
      accmean=0. 
      ablmean=0. 
      calvmean=0.  
      ablbordmean=0.
      bmeltmean=0.
      tbmean=0.
      tbdotmean=0.
      vsmean=0.
      uzsdotmean=0.
      uzkmean=0.
      hdotmean=0.
      tbdotmean=0.
      volf=0.
      volflot=0.


! calcul de mk pour les cartes :
!      where (flot(:,:))
!         mk(:,:)=1
!      elsewhere
!         mk(:,:)=0
!      endwhere
 
! 2_preparing outputs
!--------------------

      do i=1,nx 
         do j=1,ny
            if (h(i,j).gt.Hmin) then 
               if (.not.flot(i,j)) then 

                  np=np+1
                  vol=vol+h(i,j) 
!        calcul de la hauteur au dessus de la flottaison
                  if (sealevel-B(i,j).le.0.) then    ! socle au dessus du niveau des mers
                     volf=volf+h(i,j)
                  else
                     volf=volf+h(i,j)-row/ro*(sealevel-b(i,j))
                  endif


                  hmax=max(hmax,h(i,j)) 
                  smax=max(smax,s(i,j)) 
                  bmean=bm(i,j)+bmean 
                  accmean=acc(i,j)+accmean
                  tbmean=tbmean+t(i,j,nz)
                  tbdotmean=tbdotmean+tbdot(i,j)
                  vsmean=vsmean+sqrt(ux(i,j,1)**2+uy(i,j,1)**2)

                  uzsdotmean=uzsdotmean+uzsdot(i,j)
                  uzkmean=uzkmean+uzk(i,j)
                  hdotmean=hdotmean+abs(hdot(i,j)) 
                  
                  bmeltmean=bmeltmean+bmelt(i,j)
               else
                  npflot=npflot+1
                  volflot=volflot+H(i,j)
               endif
               calvmean=calvmean+calv(i,j)  
               ablbordmean=ablbordmean+ablbord(i,j)
            endif
         end do
      end do


      if (np.ne.0) then 
         hmean=vol/np 
         vol=vol*dx*dy 
         volf=volf*dx*dy
         bmean=bmean/np 
         accmean=accmean/np 
         ablmean=bmean-accmean 
         calvmean=calvmean/np 
         bmeltmean=bmeltmean/np
         ablbordmean=ablbordmean/np
         tbmean=tbmean/np
         tbdotmean=tbdotmean/np
         vsmean=vsmean/np
         uzsdotmean=uzsdotmean/np
         uzkmean=uzkmean/np
         hdotmean=hdotmean/np 
      endif

      volflot=volflot*dx*dy

      
!      print*,'np,vol', np,vol,volf,volflot,npflot,hmin,hmean

! 2_writing outputs
!------------------    
!     **** short display **** 

      write(num_ritz,906)   time,tafor,sealevel,vol,volf,np, &
           nint(hmean),nint(smax),                    &
           bmean,tbmean,nint(vsmean),                 &
           tbdotmean,hdotmean,accmean,volflot,npflot                           
      
 
! !! format 900 faux, a reprendre

906 format(f9.1,1x,f4.1,1x,f5.1,1x,e10.4,1x,e10.4,3(1x,i5),1x,f6.3,1x,f6.2,1x,i6,f5.2,1x,f5.2,1x,f5.2,1x,e10.4,1x,i5) 

    end subroutine shortoutput

  end module output_snowball_mod
